using System.Collections.Generic;
using Enums;
using Services.Interfaces;
using Structs;
using UnityEngine;
using Utils;
using Views;
using Object = UnityEngine.Object;

namespace Services {
    public class ObjectPoolService:IObjectPool<GemView> {
        private readonly GemTypeValues[] gemValues;
        private readonly Transform parent;

        private readonly Dictionary<GemType, Stack<GemView>> gemTypeToPools = new Dictionary<GemType, Stack<GemView>>();
        
        public ObjectPoolService(GemTypeValues[] gemValues, Transform parent) {
            this.gemValues = gemValues;
            this.parent = parent;
        }

        public GemView Get(GemType type, Vector2Int position, float dropHeight) {
            if (!this.gemTypeToPools.ContainsKey(type)) {
                this.gemTypeToPools.Add(type, new Stack<GemView>());
            }
            
            GemView gemView;
            Vector2 vector2Position = new Vector2(position.x, position.y + dropHeight);
            if (this.gemTypeToPools[type].Count > 0) {
                gemView = this.gemTypeToPools[type].Pop();
                
                gemView.transform.localPosition = vector2Position;
                return gemView;
            }
            
            gemView = Object.Instantiate(GemUtils.GetGemValues(type, this.gemValues).gemPrefab, vector2Position, Quaternion.identity, this.parent);
            return gemView;
        }
        
        public void Release(GemView gemView) {
            if (gemView is null)
                return;

            Object.Instantiate(GemUtils.GetGemValues(gemView.Gem.Type, this.gemValues).explosionPrefab, gemView.transform.position, Quaternion.identity, this.parent);
            
            if (!this.gemTypeToPools.ContainsKey(gemView.Gem.Type)) {
                this.gemTypeToPools.Add(gemView.Gem.Type, new Stack<GemView>());
            }
            
            gemView.gameObject.SetActive(false);
            this.gemTypeToPools[gemView.Gem.Type].Push(gemView);
            gemView.Unbind();
        }

        public void Clear() {
            foreach (Stack<GemView> pool in this.gemTypeToPools.Values) {
                pool.Clear();
            }
            
            this.gemTypeToPools.Clear();
        }
    }
}